Loading...
Searching...
No Matches
ON_Layer Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_layer.h>`

Inheritance diagram for ON_Layer:

## Public Types

enum | PER_VIEWPORT_SETTINGS { per_viewport_none = 0 , per_viewport_id = 1 , per_viewport_color = 2 , per_viewport_plot_color = 4 , per_viewport_plot_weight = 8 , per_viewport_visible = 16 , per_viewport_persistent_visibility = 32 , per_viewport_all_settings = 0xFFFFFFFF }
enum | LAYER_SETTINGS { no_layer_settings = 0 , userdata_settings = 1 , color_settings = 2 , plot_color_settings = 4 , plot_weight_settings = 8 , visible_settings = 16 , locked_settings = 32 , all_layer_settings = 0xFFFFFFFF }

## Public Member Functions

| ON_Layer ()
| ~ON_Layer ()
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON::object_type | ObjectType () const
ON_UUID | ModelObjectId () const
void | Default ()
bool | SetLayerName (const char *)
bool | SetLayerName (const wchar_t *)
const ON_wString & | LayerName () const
bool | HasPerViewportSettings (ON_UUID viewport_id, unsigned int settings_mask) const
bool | HasPerViewportSettings (const ON_UUID &viewport_id) const
bool | CopyPerViewportSettings (ON_UUID source_viewport_id, ON_UUID destination_viewport_id)
bool | CopyPerViewportSettings (const ON_Layer &source_layer, ON_UUID viewport_id, unsigned int settings_mask)
void | DeletePerViewportSettings (const ON_UUID &viewport_id) const
void | CullPerViewportSettings (int viewport_id_count, const ON_UUID *viewport_id_list)
ON__UINT32 | PerViewportSettingsCRC () const
void | SetColor (ON_Color layer_color)
void | SetPerViewportColor (ON_UUID viewport_id, ON_Color layer_color)
ON_DEPRECATED void | SetColor (ON_Color, const ON_UUID &)
ON_Color | Color () const
ON_Color | PerViewportColor (ON_UUID viewport_id) const
ON_DEPRECATED ON_Color | Color (const ON_UUID &) const
void | DeletePerViewportColor (const ON_UUID &viewport_id)
void | SetPlotColor (ON_Color plot_color)
void | SetPerViewportPlotColor (ON_UUID viewport_id, ON_Color plot_color)
ON_DEPRECATED void | SetPlotColor (ON_Color, const ON_UUID &)
ON_Color | PlotColor () const
ON_Color | PerViewportPlotColor (ON_UUID viewport_id) const
ON_DEPRECATED ON_Color | PlotColor (const ON_UUID &) const
void | DeletePerViewportPlotColor (const ON_UUID &viewport_id)
bool | SetLinetypeIndex (int linetype_index)
int | LinetypeIndex () const
bool | IsVisible () const
void | SetVisible (bool bVisible)
bool | PersistentVisibility () const
void | SetPersistentVisibility (bool bPersistentVisibility)
void | UnsetPersistentVisibility ()
bool | PerViewportIsVisible (ON_UUID viewport_id) const
ON_DEPRECATED bool | IsVisible (const ON_UUID &) const
void | SetPerViewportVisible (ON_UUID viewport_id, bool bVisible)
ON_DEPRECATED void | SetVisible (bool, const ON_UUID &)
bool | PerViewportPersistentVisibility (ON_UUID viewport_id) const
void | SetPerViewportPersistentVisibility (ON_UUID viewport_id, bool bPersistentVisibility)
void | UnsetPerViewportPersistentVisibility (ON_UUID viewport_id)
void | DeletePerViewportVisible (const ON_UUID &viewport_id)
void | GetPerViewportVisibilityViewportIds (ON_SimpleArray< ON_UUID > &viewport_id_list) const
bool | IsLocked () const
void | SetLocked (bool bLocked)
bool | PersistentLocking () const
void | SetPersistentLocking (bool bPersistentLocking)
void | UnsetPersistentLocking ()
bool | IsVisibleAndNotLocked () const
bool | IsVisibleAndLocked () const
bool | SetRenderMaterialIndex (int)
int | RenderMaterialIndex () const
bool | SetLayerIndex (int)
int | LayerIndex () const
bool | SetIgesLevel (int)
int | IgesLevel () const
double | PlotWeight () const
double | PerViewportPlotWeight (ON_UUID viewport_id) const
ON_DEPRECATED double | PlotWeight (const ON_UUID &) const
void | SetPlotWeight (double plot_weight_mm)
void | SetPerViewportPlotWeight (ON_UUID viewport_id, double plot_weight_mm)
ON_DEPRECATED void | SetPlotWeight (double, const ON_UUID &)
void | DeletePerViewportPlotWeight (const ON_UUID &viewport_id)
int | UpdateViewportIds (const ON_UuidPairList &viewport_id_map)
void | Set (unsigned int settings, const ON_Layer &settings_values)
void | SaveSettings (unsigned int settings, bool bUpdate)
unsigned int | SavedSettings () const
bool | GetSavedSettings (ON_Layer &layer, unsigned int &settings) const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual unsigned int | SizeOf () const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Static Public Member Functions

static const wchar_t * | LayerNameReferenceDelimiter ()
static const wchar_t * | LayerNamePathDelimiter ()
static bool | GetLeafName (const wchar_t *layer_name, ON_wString &leaf_name)
static bool | GetParentName (const wchar_t *layer_name, ON_wString &parent_path_name)
static bool | RemoveReferenceName (const wchar_t *layer_name, ON_wString &layer_path_name)
static bool | GetReferenceName (const wchar_t *layer_name, ON_wString &reference_name)
static unsigned int | Differences (const ON_Layer &layer0, const ON_Layer &layer1)

## Public Attributes

int | m_layer_index
ON_UUID | m_layer_id
ON_UUID | m_parent_layer_id
int | m_iges_level
int | m_material_index
ON_RenderingAttributes | m_rendering_attributes
int | m_linetype_index
ON_Color | m_color
ON_UUID | m_display_material_id
ON_Color | m_plot_color
double | m_plot_weight_mm
ON_wString | m_name
bool | m_bVisible
bool | m_bLocked
bool | m_bExpanded

## Detailed Description

Definition at line 20 of file opennurbs_layer.h.

## Member Enumeration Documentation

## LAYER_SETTINGS

enum ON_Layer::LAYER_SETTINGS

Enumerator
no_layer_settings |
userdata_settings |
color_settings |
plot_color_settings |
plot_weight_settings |
visible_settings |
locked_settings |
all_layer_settings |

Definition at line 837 of file opennurbs_layer.h.

## PER_VIEWPORT_SETTINGS

enum ON_Layer::PER_VIEWPORT_SETTINGS

Enumerator
per_viewport_none |
per_viewport_id |
per_viewport_color |
per_viewport_plot_color |
per_viewport_plot_weight |
per_viewport_visible |
per_viewport_persistent_visibility |
per_viewport_all_settings |

Definition at line 164 of file opennurbs_layer.h.

## Constructor & Destructor Documentation

## ON_Layer()

ON_Layer::ON_Layer | ( |  | ) |

## ~ON_Layer()

ON_Layer::~ON_Layer | ( |  | ) |

## Member Function Documentation

## Color() [1/2]

ON_Color ON_Layer::Color | ( |  | ) | const

## Color() [2/2]

ON_DEPRECATED ON_Color ON_Layer::Color | ( | const ON_UUID & |  | ) | const

## CopyPerViewportSettings() [1/2]

bool ON_Layer::CopyPerViewportSettings | ( | const ON_Layer & | source_layer,
|  | ON_UUID | viewport_id,
|  | unsigned int | settings_mask
| ) |  |

## CopyPerViewportSettings() [2/2]

bool ON_Layer::CopyPerViewportSettings | ( | ON_UUID | source_viewport_id,
|  | ON_UUID | destination_viewport_id
| ) |  |

## CullPerViewportSettings()

void ON_Layer::CullPerViewportSettings | ( | int | viewport_id_count,
|  | const ON_UUID * | viewport_id_list
| ) |  |

## Default()

void ON_Layer::Default | ( |  | ) |

## DeletePerViewportColor()

void ON_Layer::DeletePerViewportColor | ( | const ON_UUID & | viewport_id | ) |

## DeletePerViewportPlotColor()

void ON_Layer::DeletePerViewportPlotColor | ( | const ON_UUID & | viewport_id | ) |

## DeletePerViewportPlotWeight()

void ON_Layer::DeletePerViewportPlotWeight | ( | const ON_UUID & | viewport_id | ) |

## DeletePerViewportSettings()

void ON_Layer::DeletePerViewportSettings | ( | const ON_UUID & | viewport_id | ) | const

## DeletePerViewportVisible()

void ON_Layer::DeletePerViewportVisible | ( | const ON_UUID & | viewport_id | ) |

## Differences()

static unsigned int ON_Layer::Differences | ( | const ON_Layer & | layer0,
|  | const ON_Layer & | layer1
| ) |  |

static

## Dump()

void ON_Layer::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## GetLeafName()

static bool ON_Layer::GetLeafName | ( | const wchar_t * | layer_name,
|  | ON_wString & | leaf_name
| ) |  |

static

## GetParentName()

static bool ON_Layer::GetParentName | ( | const wchar_t * | layer_name,
|  | ON_wString & | parent_path_name
| ) |  |

static

## GetPerViewportVisibilityViewportIds()

void ON_Layer::GetPerViewportVisibilityViewportIds | ( | ON_SimpleArray< ON_UUID > & | viewport_id_list | ) | const

## GetReferenceName()

static bool ON_Layer::GetReferenceName | ( | const wchar_t * | layer_name,
|  | ON_wString & | reference_name
| ) |  |

static

## GetSavedSettings()

bool ON_Layer::GetSavedSettings | ( | ON_Layer & | layer,
|  | unsigned int & | settings
| ) |  | const

## HasPerViewportSettings() [1/2]

bool ON_Layer::HasPerViewportSettings | ( | const ON_UUID & | viewport_id | ) | const

## HasPerViewportSettings() [2/2]

bool ON_Layer::HasPerViewportSettings | ( | ON_UUID | viewport_id,
|  | unsigned int | settings_mask
| ) |  | const

## IgesLevel()

int ON_Layer::IgesLevel | ( |  | ) | const

## IsLocked()

bool ON_Layer::IsLocked | ( |  | ) | const

## IsValid()

ON_BOOL32 ON_Layer::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## IsVisible() [1/2]

bool ON_Layer::IsVisible | ( |  | ) | const

## IsVisible() [2/2]

ON_DEPRECATED bool ON_Layer::IsVisible | ( | const ON_UUID & |  | ) | const

## IsVisibleAndLocked()

bool ON_Layer::IsVisibleAndLocked | ( |  | ) | const

## IsVisibleAndNotLocked()

bool ON_Layer::IsVisibleAndNotLocked | ( |  | ) | const

## LayerIndex()

int ON_Layer::LayerIndex | ( |  | ) | const

## LayerName()

const ON_wString & ON_Layer::LayerName | ( |  | ) | const

## LayerNamePathDelimiter()

static const wchar_t * ON_Layer::LayerNamePathDelimiter | ( |  | ) |

static

## LayerNameReferenceDelimiter()

static const wchar_t * ON_Layer::LayerNameReferenceDelimiter | ( |  | ) |

static

## LinetypeIndex()

int ON_Layer::LinetypeIndex | ( |  | ) | const

## ModelObjectId()

ON_UUID ON_Layer::ModelObjectId | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## ObjectType()

ON::object_type ON_Layer::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## PersistentLocking()

bool ON_Layer::PersistentLocking | ( |  | ) | const

## PersistentVisibility()

bool ON_Layer::PersistentVisibility | ( |  | ) | const

## PerViewportColor()

ON_Color ON_Layer::PerViewportColor | ( | ON_UUID | viewport_id | ) | const

## PerViewportIsVisible()

bool ON_Layer::PerViewportIsVisible | ( | ON_UUID | viewport_id | ) | const

## PerViewportPersistentVisibility()

bool ON_Layer::PerViewportPersistentVisibility | ( | ON_UUID | viewport_id | ) | const

## PerViewportPlotColor()

ON_Color ON_Layer::PerViewportPlotColor | ( | ON_UUID | viewport_id | ) | const

## PerViewportPlotWeight()

double ON_Layer::PerViewportPlotWeight | ( | ON_UUID | viewport_id | ) | const

## PerViewportSettingsCRC()

ON__UINT32 ON_Layer::PerViewportSettingsCRC | ( |  | ) | const

## PlotColor() [1/2]

ON_Color ON_Layer::PlotColor | ( |  | ) | const

## PlotColor() [2/2]

ON_DEPRECATED ON_Color ON_Layer::PlotColor | ( | const ON_UUID & |  | ) | const

## PlotWeight() [1/2]

double ON_Layer::PlotWeight | ( |  | ) | const

## PlotWeight() [2/2]

ON_DEPRECATED double ON_Layer::PlotWeight | ( | const ON_UUID & |  | ) | const

## Read()

ON_BOOL32 ON_Layer::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

## RemoveReferenceName()

static bool ON_Layer::RemoveReferenceName | ( | const wchar_t * | layer_name,
|  | ON_wString & | layer_path_name
| ) |  |

static

## RenderMaterialIndex()

int ON_Layer::RenderMaterialIndex | ( |  | ) | const

## SavedSettings()

unsigned int ON_Layer::SavedSettings | ( |  | ) | const

## SaveSettings()

void ON_Layer::SaveSettings | ( | unsigned int | settings,
|  | bool | bUpdate
| ) |  |

## Set()

void ON_Layer::Set | ( | unsigned int | settings,
|  | const ON_Layer & | settings_values
| ) |  |

## SetColor() [1/2]

void ON_Layer::SetColor | ( | ON_Color | layer_color | ) |

## SetColor() [2/2]

ON_DEPRECATED void ON_Layer::SetColor | ( | ON_Color | ,
|  | const ON_UUID & |
| ) |  |

## SetIgesLevel()

bool ON_Layer::SetIgesLevel | ( | int |  | ) |

## SetLayerIndex()

bool ON_Layer::SetLayerIndex | ( | int |  | ) |

## SetLayerName() [1/2]

bool ON_Layer::SetLayerName | ( | const char * |  | ) |

## SetLayerName() [2/2]

bool ON_Layer::SetLayerName | ( | const wchar_t * |  | ) |

## SetLinetypeIndex()

bool ON_Layer::SetLinetypeIndex | ( | int | linetype_index | ) |

## SetLocked()

void ON_Layer::SetLocked | ( | bool | bLocked | ) |

## SetPersistentLocking()

void ON_Layer::SetPersistentLocking | ( | bool | bPersistentLocking | ) |

## SetPersistentVisibility()

void ON_Layer::SetPersistentVisibility | ( | bool | bPersistentVisibility | ) |

## SetPerViewportColor()

void ON_Layer::SetPerViewportColor | ( | ON_UUID | viewport_id,
|  | ON_Color | layer_color
| ) |  |

## SetPerViewportPersistentVisibility()

void ON_Layer::SetPerViewportPersistentVisibility | ( | ON_UUID | viewport_id,
|  | bool | bPersistentVisibility
| ) |  |

## SetPerViewportPlotColor()

void ON_Layer::SetPerViewportPlotColor | ( | ON_UUID | viewport_id,
|  | ON_Color | plot_color
| ) |  |

## SetPerViewportPlotWeight()

void ON_Layer::SetPerViewportPlotWeight | ( | ON_UUID | viewport_id,
|  | double | plot_weight_mm
| ) |  |

## SetPerViewportVisible()

void ON_Layer::SetPerViewportVisible | ( | ON_UUID | viewport_id,
|  | bool | bVisible
| ) |  |

## SetPlotColor() [1/2]

void ON_Layer::SetPlotColor | ( | ON_Color | plot_color | ) |

## SetPlotColor() [2/2]

ON_DEPRECATED void ON_Layer::SetPlotColor | ( | ON_Color | ,
|  | const ON_UUID & |
| ) |  |

## SetPlotWeight() [1/2]

void ON_Layer::SetPlotWeight | ( | double | plot_weight_mm | ) |

## SetPlotWeight() [2/2]

ON_DEPRECATED void ON_Layer::SetPlotWeight | ( | double | ,
|  | const ON_UUID & |
| ) |  |

## SetRenderMaterialIndex()

bool ON_Layer::SetRenderMaterialIndex | ( | int |  | ) |

## SetVisible() [1/2]

void ON_Layer::SetVisible | ( | bool | bVisible | ) |

## SetVisible() [2/2]

ON_DEPRECATED void ON_Layer::SetVisible | ( | bool | ,
|  | const ON_UUID & |
| ) |  |

## UnsetPersistentLocking()

void ON_Layer::UnsetPersistentLocking | ( |  | ) |

## UnsetPersistentVisibility()

void ON_Layer::UnsetPersistentVisibility | ( |  | ) |

## UnsetPerViewportPersistentVisibility()

void ON_Layer::UnsetPerViewportPersistentVisibility | ( | ON_UUID | viewport_id | ) |

## UpdateViewportIds()

int ON_Layer::UpdateViewportIds | ( | const ON_UuidPairList & | viewport_id_map | ) |

## Write()

ON_BOOL32 ON_Layer::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## Member Data Documentation

## m_bExpanded

bool ON_Layer::m_bExpanded

Definition at line 828 of file opennurbs_layer.h.

## m_bLocked

bool ON_Layer::m_bLocked

Definition at line 827 of file opennurbs_layer.h.

## m_bVisible

bool ON_Layer::m_bVisible

Definition at line 826 of file opennurbs_layer.h.

## m_color

ON_Color ON_Layer::m_color

Definition at line 815 of file opennurbs_layer.h.

## m_display_material_id

ON_UUID ON_Layer::m_display_material_id

Definition at line 816 of file opennurbs_layer.h.

## m_iges_level

int ON_Layer::m_iges_level

Definition at line 783 of file opennurbs_layer.h.

## m_layer_id

ON_UUID ON_Layer::m_layer_id

Definition at line 776 of file opennurbs_layer.h.

## m_layer_index

int ON_Layer::m_layer_index

Definition at line 775 of file opennurbs_layer.h.

## m_linetype_index

int ON_Layer::m_linetype_index

Definition at line 804 of file opennurbs_layer.h.

## m_material_index

int ON_Layer::m_material_index

Definition at line 801 of file opennurbs_layer.h.

## m_name

ON_wString ON_Layer::m_name

Definition at line 824 of file opennurbs_layer.h.

## m_parent_layer_id

ON_UUID ON_Layer::m_parent_layer_id

Definition at line 777 of file opennurbs_layer.h.

## m_plot_color

ON_Color ON_Layer::m_plot_color

Definition at line 819 of file opennurbs_layer.h.

## m_plot_weight_mm

double ON_Layer::m_plot_weight_mm

Definition at line 821 of file opennurbs_layer.h.

## m_rendering_attributes

ON_RenderingAttributes ON_Layer::m_rendering_attributes

Definition at line 802 of file opennurbs_layer.h.

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_layer.h